// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
char com2_rx_data,com2_rx_eflg = 0;				// COM2   ͷƮ  /÷

int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī
int timer3_cnt = 0;						// Ÿ̸3 ͷƮ  ī

int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
int exint1_flg = 0;						// EXINT1 ͷƮ  ÷
int exint2_flg = 0;						// EXINT2 ͷƮ  ÷
int exint3_flg = 0;						// EXINT3 ͷƮ  ÷
int exint4_flg = 0;						// EXINT4 ͷƮ  ÷
int exint5_flg = 0;						// EXINT5 ͷƮ  ÷
int exint6_flg = 0;						// EXINT6 ͷƮ  ÷
int exint7_flg = 0;						// EXINT7 ͷƮ  ÷

unsigned int adc_int_data = 0;					// ADC ͷƮ  
int adc_int_ch = 0;						// ADC CH ͷƮ 
int adc_int_flg = 0;						// ADC ͷƮ  ÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{

// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg             
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg             
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// PortE 
	PORTE=0x00;						// Ʈ  reg             
	DDRE=0x00;                                              // Ʈ  reg(0Է,1)
// PortF 
	PORTF=0x00;						// Ʈ  reg             
	DDRF=0x00;                                              // Ʈ  reg(0Է,1)
// PortG 
	PORTG=0x00;						// Ʈ  reg             
	DDRG=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	ASSR=0x00;
	TCCR0=0x00;
	TCNT0=0x00;
	OCR0=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;

// Timer/Counter2 
	TCCR2=0x00;
	TCNT2=0x00;
	OCR2=0x00;

// Timer/Counter3 
	TCCR3A=0x00;
	TCCR3B=0x00;
	TCNT3H=0x00;
	TCNT3L=0x00;
	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
	EICRA=0x00;
	EICRB=0x00;
	EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK=0x00;
	ETIMSK=0x00;

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

//  ʱȭ(COM2)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR1A=0x00;
	UCSR1B=0x98;
	UCSR1C=0x06;
	UBRR1H=0x00;
	UBRR1L=0x33;

// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): None
//	MCUCR=0x80;
//	XMCRA=0x00;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

	fdevopen(putchar_0,getchar_0,0);
// Global enable interrupts
	sei();
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_UART0_RECV)
{
char status,data;

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

}

// ============================== COM2  ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_UART1_RECV)
{
char status,data;

	status=UCSR1A;
	data=UDR1;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com2_rx_data = data;
		com2_rx_eflg = 1;
	}
}

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW0)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_cnt++;						// Ÿ̸0 ī
}

// ========================== TIMER1 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW1)
{
	TCNT1 = 63035;						// 65535 - 2500 = 63035
	timer1_cnt++;						// Ÿ̸1 ī
}

// ========================== TIMER2 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW2)
{
	TCNT2 = 99;						// 255-156 = 100
	timer2_cnt++;						// Ÿ̸2 ī
}

// ========================== TIMER3 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW3)
{
	TCNT3H=0xf6;  						// 65535 - 2500 = 63035
	TCNT3L=0x3b;
	timer3_cnt++;						// Ÿ̸3 ī
}

// ========================== ܺ INT0 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT0)
{
	exint0_flg = 1;						// EXINT0 ÷ ON
}

// ========================== ܺ INT1 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT1)
{
	exint1_flg = 1;						// EXINT1 ÷ ON
}

// ========================== ܺ INT2 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT2)
{
	exint2_flg = 1;						// EXINT2 ÷ ON
}

// ========================== ܺ INT3 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT3)
{
	exint3_flg = 1;						// EXINT3 ÷ ON
}

// ========================== ܺ INT4 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT4)
{
	exint4_flg = 1;						// EXINT4 ÷ ON
}

// ========================== ܺ INT5 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT5)
{
	exint5_flg = 1;						// EXINT5 ÷ ON
}

// ========================== ܺ INT6 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT6)
{
	exint6_flg = 1;						// EXINT6 ÷ ON
}

// ========================== ܺ INT7 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT7)
{
	exint7_flg = 1;						// EXINT7 ÷ ON
}

// =============================== ADC ͷƮ ===============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_ADC)
{
	adc_int_data = ADCW;					// ADC
	adc_int_flg = 1;					// ADC Ϸ ÷ 
}

// ============================== COM1 1Ʈ ۽ =========================
// [μ] char data
// item1:  
// --------------------------------------------------------------------------
int putchar_0(char data)
{
	if(data == '\n'){
		while((UCSR0A & DATA_REGISTER_EMPTY) == 0);
		UDR0 = '\r';
	}
	while((UCSR0A & DATA_REGISTER_EMPTY) == 0);
	UDR0 = data;
	return(0);
}

// ============================== COM1 1Ʈ  =========================
// [μ] void
// []  
// --------------------------------------------------------------------------
int getchar_0(void)
{
	while((UCSR0A & RX_COMPLETE) == 0);
	return(UDR0);
}
